/*
 * Input Group
 *
 * Easily extend form controls
 * by adding text, buttons, or button groups
 * on either side of textual inputs, custom selects, and custom file inputs.
 *
 * Index
 * - Input group
 * - Prepend / append
 * - Text or icon addon
 * - Round corners
 * - Error
 * - Disabled
 */

:host {
  display: block;
}

/* INPUT GROUP
 -------------------- */

.input-group {
  position: relative;
  display: flex;
  flex-wrap: wrap;
  align-items: stretch;
  width: 100%;
  font-family: var(--road-font, sans-serif);
}

::slotted(road-input),
::slotted(input),
::slotted(textarea),
::slotted(road-select) {
  position: relative;
  flex: 1 1 auto;
  width: 1%;
  margin-bottom: 0;
}

/**
 * Remove border for append and prepend element
 * with white background
 */

::slotted([slot="prepend"]) {
  margin-right: -3px;
  border-color: var(--road-input-outline);
  border-right-color: transparent;
  border-top-right-radius: 0;
  border-bottom-right-radius: 0;
}

::slotted([slot="append"]) {
  margin-left: -0.25rem;
  border-color: var(--road-input-outline);
  border-left-width: 0;
}

/**
 * Hover state
 */

@media (hover: hover) {

  .input-group:not(.is-disabled):hover ::slotted([slot="prepend"]) {
    border-color: var(--road-input-outline-variant);
    border-right-color: transparent;
  }

  .input-group:not(.is-disabled):hover ::slotted([slot="append"]) {
    border-color: var(--road-input-outline-variant);
    border-left-color: transparent;
  }

  :host(.phone-number-group) .input-group:not(.is-disabled):hover ::slotted([slot="prepend"]) {
    border-color: var(--road-input-outline-variant);
  }
}

/**
 * Focus state
 */
/* Pour les éléments slottés [slot="prepend"] */

.input-group:focus-within ::slotted([slot="prepend"]),
:host(.phone-number-group) .input-group:focus-within ::slotted([slot="prepend"]) {
  border-color: var(--road-grey-0);
  border-width: 2px;
  border-right-color: transparent;
  outline: none; /* Affiche l'outline par défaut au focus */
}

/* Pour les éléments slottés [slot="append"] */

.input-group:focus-within ::slotted([slot="append"]) {
  border-color: var(--road-grey-0);
  border-width: 2px;
  border-left-color: transparent;
  outline: none; /* Affiche l'outline par défaut au focus */
}

/* Pour le champ principal dans road-input */

.input-group:focus-within ::slotted(road-input):focus-visible {
  border-color: var(--road-grey-0);
  border-width: 2px;
  outline: none; /* Active le contour d'accessibilité par défaut */
}




/* PREPEND - APPEND
 -------------------- */

.input-group-prepend,
.input-group-append {
  display: flex;
  height: 3rem;
}

::slotted(road-button) {
  --padding-start: 0.5rem;
  --padding-end: 0.5rem;

  position: relative;
  z-index: 2;
  min-width: 3rem;
  margin: 0;
  font-size: var(--road-font-size-14);
}

::slotted(road-button):hover {
  background-color: var(--road-button-ghost-variant);
}

.input-group-prepend {
  z-index: 1;
  order: -1;
}

.input-group-prepend ~ .form-label {
  left: calc(3rem + 1px);
}

.input-group-append {
  position: relative;
  z-index: 1;
  border-radius: 0 0.25rem 0.25rem 0;
}

/* TEXT OR ICON ADDON
 -------------------- */

::slotted(label) {
  display: flex;
  align-items: center;
  padding: 0 0.5rem;
  margin-bottom: 0;
  color: var(--road-on-surface);
  text-align: center;
  white-space: nowrap;
  cursor: text;
  background: var(--road-surface);
  border: 1px solid var(--road-input-outline);
  border-radius: 0.25rem;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

::slotted(road-label) {
  display: flex;
  align-items: center;
  padding: 0 0.5rem;
  margin-bottom: 0;
  color: var(--road-on-surface);
  text-align: center;
  white-space: nowrap;
  cursor: text;
  background: var(--road-surface);
  border: 1px solid var(--road-input-outline);
  border-radius: 0.25rem;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

/* ROUND CORNERS
 -------------------- */

::slotted(road-input:not(:first-child)),
::slotted(road-select:not(:first-child)) {
  border-radius: 0;
}

.input-group-append ::slotted([slot="append"]) {
  border-left: 0;
  border-top-left-radius: 0;
  border-bottom-left-radius: 0;
}

.input-group-prepend ::slotted([slot="prepend"]) {
  border-right: 0;
  border-top-right-radius: 0;
  border-bottom-right-radius: 0;
}

:host(.phone-number-group) .input-group-prepend ::slotted([slot="prepend"]) {
  border-right: 1px solid var(--road-input-outline);
  border-top-right-radius: 0;
  border-bottom-right-radius: 0;
}

.input-group-prepend ::slotted(label) {
  margin-right: calc(-1rem + 1px);
}

.input-group-append ::slotted(road-button) {
  background-color: var(--road-surface);
}

.input-group-append:hover ::slotted(road-button) {
  background-color: var(--road-button-ghost-variant);
}


/* SIZES
 -------------------- */

.size-xl .input-group-prepend,
.size-xl .input-group-append {
  height: 3.5rem;
}

.size-xl ::slotted(road-button) {
  height: 3.5rem;
}

/* ERROR
 -------------------- */

.input-group.is-invalid ::slotted([slot="append"]),
.input-group.is-invalid ::slotted([slot="prepend"]) {
  border-color: var(--road-danger-outline);
}

:host(.phone-number-group) .input-group.is-invalid ::slotted([slot="prepend"]) {
  border-color: var(--road-danger-outline);
}

/* DISABLED
-------------------- */

:host([disabled]) {
  cursor: not-allowed;
}

:host([disabled]) .input-group {
  pointer-events: none; /* Désactive les interactions avec l'ensemble du groupe */
}

:host([disabled]) ::slotted([slot="append"]),
:host([disabled]) ::slotted([slot="prepend"]) {
  color: var(--road-on-surface-disabled);
  cursor: not-allowed;
  background: #e4e5e9;
}

:host([disabled]) ::slotted([slot="append"] road-icon),
:host([disabled]) ::slotted([slot="prepend"] road-icon) {
  color: var(--road-on-surface-disabled);
}

:host([disabled]) road-icon {
  color: var(--road-on-surface-disabled);
}



